import { appendDOM } from './array-mapper.dom';
import { generate } from './array-mapper.generate.map';
import { panel } from './array-mapper.panel';
import { structure } from './array-mapper.structure';
import { events } from './array-mapper.events';

export const attachAppendDOM = () => {
    appendDOM.arrLength();
    appendDOM.memoryAmount();
};

export const attachPanel = (() => {
    return {
        once: () => {
            panel.pushValue();
        },
        more: () => {
            panel.findValue();
            panel.selectIndex();
        },
        all: () => {
            panel.pushValue();
            panel.removeValue();
            panel.findValue();
            panel.selectIndex();
        }
    }
})();

export const attachStructure = () => {
    structure.arrayStructure();
    structure.arrayDiagram();
};

export const attachEvents = () => {
    events.showData();
    events.selectBoxCell();
    events.resetSelected();
};

export const refreshNewValue = (value) => {
    const box = document.querySelector('.js-box');
    const cell = document.createElement('div');
    cell.setAttribute('arr-value', value);
    cell.classList.add('js-cell');
    box.appendChild(cell);
    generate.setBoxCells();

    refreshView();
}

export const refreshRemovedValue = (value) => {
    appendDOM.removeCell(value);
    refreshView();
}


export const refreshView = () => {
    attachAppendDOM();
    attachPanel.more();
    attachStructure();
}

window.onload = () => {
    attachEvents();
    attachAppendDOM();
    attachPanel.all();
    attachStructure();
}