import { show } from './array-mapper.show';
import { generate } from './array-mapper.generate.map';

export const appendDOM = (() => {
    const position1 = document.querySelector('.js-data-index-1');
    const position2 = document.querySelector('.js-data-index-2');
    const distance = document.querySelector('.js-data-distance');
    const arrayLength = document.querySelector('.js-data-array-length');
    const memoryArray = document.querySelector('.js-data-memory-array');
    const sumOfSelected = document.querySelector('.js-data-sum');
    
    let min,  max;
    return {
        distance: (value) => {
            position1.innerHTML = value[0];
            position2.innerHTML = value[1] || 0;

            if (value[0] && value[1]) {
                min = Math.min(...value);
                max = Math.max(...value);
                distance.innerHTML = max - min;
            } else {
                return 0;
            }
        },
        resetAll: () => {
            position1.innerHTML = 0;
            position2.innerHTML = 0;
            distance.innerHTML = 0;
            sumOfSelected.innerHTML = 0;
        },
        arrLength: () => {
            arrayLength.innerHTML = show.arrLength() || 0;
        },
        memoryAmount: () => {
            memoryArray.innerHTML = show.memoryAmount();
        },
        arrayStructure: (selector) => {
            const arr = generate.getArray();
            const structure = JSON.stringify(arr);
            selector.innerHTML = structure.split('],').join(']<br>');
        },
        sumOfSelected: (sum) => {
            sumOfSelected.textContent = sum;
        },
        removeCell: (value) => {
            console.log(value);
            const box = document.querySelector('.js-box');
            const cells = document.querySelectorAll('.js-cell');
            const valueIndx = Array.from(cells, (val, indx) => {
                let cellIndx = indx;
               if (Number(value) === Number(val.attributes[0].value)) {
                   box.removeChild(cells[cellIndx]);
               }
            });
        }
    }
})();

