import { get } from './array-mapper.get';
import { show } from './array-mapper.show'
import { generate } from './array-mapper.generate.map';
import { reset } from './array-mapper.reset';

export const events = (() => {
    return {
        showData: () => {
            generate.getBoxCells().map((val, indx) => {
                val.addEventListener('mouseenter', () => {
                    val.innerHTML = get.template(indx, val);
                });

                val.addEventListener('mouseleave', () => {
                    if (!val.classList.contains('selected')) {
                        val.innerHTML = '';
                    }
                });
            });
        },
        selectBoxCell: () => {
            generate.getBoxCells().map((val, indx) => {
                val.addEventListener('click', () => {
                    val.innerHTML = get.template(indx, val);
                    show.distance(indx, val);
                    show.sumOfSelected(val);
                });
            });
        },
        resetSelected: () => {
            const resetBtn = document.querySelector('.js-reset-selected');
            generate.getBoxCells().map((val, indx) => {
                resetBtn.addEventListener('click', () => reset.selected(val));
            });
        }
    }
})();