import { get } from './array-mapper.get';
import { generate } from './array-mapper.generate.map';
import { show } from './array-mapper.show';
import { refreshRemovedValue, refreshNewValue } from './array-mapper.core';

export const panel = (() => {
    const selectIndexBtn = document.querySelector('.js-select-index-btn');
    const selectIndexInput = document.querySelector('.js-select-index-input');
    const findValueBtn = document.querySelector('.js-find-value-btn');
    const inputFindValue = document.querySelector('.js-find-value-input');
    const pushValueBtn = document.querySelector('.js-push-value-btn');
    const pushValueInput = document.querySelector('.js-push-value-input');
    const removeValueInput = document.querySelector('.js-remove-value-input');
    const removeValueBtn = document.querySelector('.js-remove-value-btn');

    return {
        selectIndex: () => {
            const showIndex = () => {
                generate.getBoxCells().map((val, indx) => {
                    if (val.classList.contains('selected')) {
                        val.classList.remove('selected');
                        val.innerHTML = '';
                    }
    
                    if (indx === Number(selectIndexInput.value)) {
                        val.classList.add('selected');
                        val.innerHTML = get.template(indx, val);
                    }
                });
            };
    
            selectIndexBtn.addEventListener('click', showIndex);
        },
        findValue: () => {
            findValueBtn.addEventListener('click', () => {
                generate.getBoxCells().map((val, indx) => {
                    if (val.classList.contains('selected')) {
                        val.classList.remove('selected');
                        val.innerHTML = '';
                    }
                    if (show.attribute(val) === inputFindValue.value) {
                        val.classList.add('selected');
                        val.innerHTML = get.template(indx, val);
                    }
                });
            });
        },
        pushValue: () => {
            pushValueBtn.addEventListener('click', () => {
                const pushValue = Number(pushValueInput.value);
                const arr = generate.getArray();
                const lastArray = arr[arr.length -1].length;
                const arr1 = [];
                
                if (lastArray >= 7) {
                    arr1.push(pushValue);
                    arr.push(arr1);
                } else {
                    arr[arr.length -1].push(pushValue);
                }

                refreshNewValue(pushValue);
            });
        },
        removeValue: () => {
            removeValueBtn.addEventListener('click', () => {
                const removedValue = Number(removeValueInput.value);
                const arr = generate.getArray();
                const findRemovedValue = element => element === removedValue;
                const result = arr.map((val, indx) => {
                    const values = val.findIndex(findRemovedValue);
                    if (values !== (-1)) {
                        let valueToRemove = arr[indx].splice(values, 1);
                        refreshRemovedValue(valueToRemove);
                    }
                });
            });
        }
    }
})();