import { appendDOM } from './array-mapper.dom';
import { generate } from './array-mapper.generate.map';

export const show = (() => {
    const countSelectedArr = [];
    let position = [];
    let count = 0;
    return {
        flushAll: () => {
            position.length = 0;
            countSelectedArr.length = 0; 
            count = 0;
        },
        attribute: (val) => {
            return val.attributes.getNamedItem('arr-value').value;
        },
        distance: (indx, val) => {
            count += 1;
            if (count >= 3) {
                return false;
            } else {
                val.classList.add('selected');
                if (position[0]) {
                    position[1] = indx;
                    appendDOM.distance(position)
                } else {
                    position[0] = indx;
                    appendDOM.distance(position);
                }
            }
        },
        sumOfSelected: (value) => {
            const attrValue = Number(show.attribute(value));
            countSelectedArr.push(attrValue);
            if (countSelectedArr.length >= 2) {
                const sum = countSelectedArr.reduce((x, y) => x + y);
                appendDOM.sumOfSelected(sum);
            }
        },
        arrLength: () => {
            return generate.getArray().length;
        },
        memoryAmount: () => {
            const emptyArray = 32;
            const numberByte = 9.7;
            let result;
            result = generate.getArray().map((val, indx) => val.length);
            result = result.reduce((x, y) => x + y);
            result = (emptyArray + (numberByte * result)).toPrecision(3);
            
            return `${result} bytes`;
        }
    }
})();